/*
Dati i seguenti indirizzi IP verificare l'appartenenza alla stessa rete.
*/
#include <stdio.h>

typedef struct {
  unsigned char mask;
  unsigned char leading;
  unsigned int netmask;
} CLASSFUL;
CLASSFUL classiIp[] = {{0x80,0x00,0xff000000},{0xc0,0x80,0xffff0000},{0xe0,0xc0,0xffffff00}};

typedef struct {
  unsigned char a,b,c,d;
  unsigned int ip;
  unsigned int netid;
} IPINFO;
IPINFO Ip[4];

int main (void)
{
  int i,j;

  Ip[0].a= 10;Ip[0].b=  1;Ip[0].c=  0;Ip[0].d=3;
  Ip[1].a=192;Ip[1].b=168;Ip[1].c=  0;Ip[1].d=1;
  Ip[2].a=137;Ip[2].b=168;Ip[2].c=  0;Ip[2].d=1;
  Ip[3].a=137;Ip[3].b=168;Ip[3].c=249;Ip[3].d=17;

  i = 0;
  for (i=0; i<4; i++)
  {
    for (j=0;j<3;j++)
    {
      Ip[i].ip = Ip[i].a*0x1000000 + Ip[i].b*0x10000 + Ip[i].c*0x100 + Ip[i].d;
      if ((Ip[i].a & classiIp[j].mask) == classiIp[j].leading)
      {
        Ip[i].netid = Ip[i].ip & classiIp[j].netmask;
        printf("\n%3d.%3d.%3d.%3d",Ip[i].a,Ip[i].b,Ip[i].c,Ip[i].d);
        printf(" e' di classe %c (netmask: %x) con netId %08X",'A'+j, classiIp[j].netmask, Ip[i].netid);
      }
    }
  }

  for (i=0; i<4-1; i++)
  {
    for (j=i+1;j<4;j++)
    {
      if (Ip[i].netid==Ip[j].netid)
      {
        printf("\n%d.%d.%d.%d",Ip[i].a,Ip[i].b,Ip[i].c,Ip[i].d);
        printf(" e %d.%d.%d.%d stessa rete",Ip[j].a,Ip[j].b,Ip[j].c,Ip[j].d);
      }
    }
  }

  return 0;
}







unsigned int DottedToDecimal(unsigned char a,unsigned char b,unsigned char c,unsigned char d)
{
  unsigned int ul;

  ul = a*0x1000000;
  ul = ul + b*0x10000;
  ul = ul + c*0x100;
  ul = ul + d;

  return ul;

}
